internal_function
void* dump (void *arg)
{
    pthread_setcanceltype (PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
    XML_Dump_Metadata *xml_dump = arg;

    fprintf(xml_dump->file,
            "<!--This XML file is generated in a lazy fashion, when the server is in a \n"
            "quiscent state. This means that this file may end up being incomplete if\n"
            "the server is killed forcefully before this dump is complete. -->\n\n"
            "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<KVStore>\n");
    fflush(xml_dump->file);

    DIR *dir0 = opendir(".");
    if (dir0 == NULL) {
        perror("Can't open directory for xml dump");
        return NULL;
    }

    for (struct dirent *entry1 = readdir(dir0); entry1 != NULL; entry1 = readdir(dir0)) {
        Char path1[300] = {0};
        strcat(path1, entry1->d_name);
        strcat(path1, "/");
        DIR *dir1 = opendir(path1);

        if (strcmp(entry1->d_name, ".") == 0 || strcmp(entry1->d_name, "..") == 0) continue;
        if (entry1->d_type != DT_DIR) continue;

        for (struct dirent *entry2 = readdir(dir1); entry2 != NULL; entry2 = readdir(dir1)) {
            Char path2[300] = {0};
            strcat(path2, path1);
            strcat(path2, entry2->d_name);
            strcat(path2, "/");
            DIR *dir2 = opendir(path2);

            if (strcmp(entry2->d_name, ".") == 0 || strcmp(entry2->d_name, "..") == 0) continue;

            for (struct dirent *entry3 = readdir(dir2); entry3 != NULL; entry3 = readdir(dir2)) {
                Char path3[300] = {0};
                strcat(path3, path2);
                strcat(path3, entry3->d_name);
                strcat(path3, "/");
                DIR *dir3 = opendir(path3);

                if (strcmp(entry3->d_name, ".") == 0 || strcmp(entry3->d_name, "..") == 0) continue;

                for (struct dirent *entry4 = readdir(dir3); entry4 != NULL; entry4 = readdir(dir3)) {
                    Char path4[300] = {0};
                    strcat(path4, path3);
                    strcat(path4, entry4->d_name);
                    strcat(path4, "/");
                    DIR *dir4 = opendir(path4);

                    if (strcmp(entry4->d_name, ".") == 0 || strcmp(entry4->d_name, "..") == 0) continue;

                    for (struct dirent *entry_f = readdir(dir4); entry_f != NULL; entry_f = readdir(dir4)) {
                        if (strcmp(entry_f->d_name, ".") == 0 || strcmp(entry_f->d_name, "..") == 0) continue;

                        Char path_f[300] = {0};
                        strcat(path_f, path4);
                        strcat(path_f, entry_f->d_name);

                        Char *value = calloc((KiB(256) + 1), sizeof(*value));

                        FILE* value_file = fopen(path_f, "r");
                        fseek(value_file, 0L, SEEK_END);
                        Size size = ftell(value_file);
                        fseek(value_file, 0L, SEEK_SET);
                        fread(value, size, sizeof(*value), value_file);
                        fclose(value_file);

                        fprintf(xml_dump->file, "\t<KVPair>\n\t\t<Key>​%s​</Key>\n\t\t<Value>%s</Value>\n\t</KVPair>\n",
                                entry_f->d_name, value);
                        fflush(xml_dump->file);
                        free(value);
                    }

                    closedir(dir4);
                }

                closedir(dir3);
            }

            closedir(dir2);
        }

        closedir(dir1);
    }

    fprintf(xml_dump->file, "</KVStore>");
    fflush(xml_dump->file);
    closedir(dir0);

    return NULL;
}
